AFRAME.registerComponent('grabbable', {
  schema: {
    target: {type: 'selector'},
    event: {type: 'string', default: 'click'},
  },
  init: function () {
    this.grabbedBy = null;
    this.el.addEventListener(this.data.event, evt => this.grab());
  },
  grab: function () {
    if (this.grabbedBy) return;
    this.grabbedBy = this.data.target;
    this.el.emit('grabbed');
  },
  ungrab: function () {
    if (!this.grabbedBy) return;
    this.grabbedBy = null;
    this.el.emit('ungrabbed');
  },
  tick: function (time, deltaT) {
    if (!this.grabbedBy) return;
    this.el.object3D.position.setFromMatrixPosition(this.grabbedBy.object3D.matrixWorld);
    this.el.object3D.rotation.copy(this.grabbedBy.object3D.rotation);
  }
});